// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "counter.hh"

Counter::Counter()
{
  s = 1;
  count = 0;
  type = loop;
}

Counter::Counter(int a)
{
  s = a;
  count = 0;
  type = loop;
}

int
Counter::operator++()
{
  ++count;
  
  if (count >= s) {
    if (type == once)
      count = s - 1;
    else 
      count = 0;
  }
  
  return count;
}

int
Counter::operator--()
{
 --count;

 if (count < 0) {
   count = s - 1;
 }
 return count;
}

int
Counter::get_value()
{
  return count;
}

int
Counter::set_count(int i)
{
  return count = i;
}

int
Counter::set_size(int new_size)
{
  s = new_size;
  if (count > s || count < 0) {
    count = 0;
  }
}

int 
Counter::size()
{
  return s;
}

void 
Counter::set_type(CounterType new_type)
{
  type = new_type;
}

/* EOF */
