// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <ClanLib/clanlib.h>

#include "counter.hh"
#include "window.hh"
#include "globals.hh"

Window::Window()
{
}

// Add an object to the object list
void
Window::add_obj(GuiObj* new_obj)
{
  obj.push_back(new_obj);
}

// Redraw the complete screen/window
void
Window::draw()
{
  for(int i=0; i < obj.size(); ++i) 
    obj[i]->draw_clipped();
}

// Let the window move its content
void
Window::let_move()
{
  for(int i=0; i < obj.size(); ++i) 
    obj[i]->let_move();
}

void
Window::main_loop()
{
  // BUG: Ok, this funtion works, but it is't very nice it should be
  // complitly rewritten. Also the window class for the game should be 
  
  bool quit = false;
  int  time = CL_System::get_time();
  int fps = 0;
  
  while (quit != true) {
    CL_System::keep_alive();

    if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_ESCAPE) == true) {
      quit = true;
      for(int i=0; i < obj.size(); ++i) 
	obj[i]->write_results();
      continue;
    }
      
    if (print_fps && (CL_System::get_time()-time) > 1000 ) {
      cout << fps << " fps" << endl;
      fps = 0;
      time = CL_System::get_time();
    }

    ++fps;
    Window::let_move();
    Window::draw();
    CL_Display::flip_display();
  }
}

/* EOF */
